//
//  ViewController.m
//  Test
//
//  Created by 余西安 on 15/6/1.
//  Copyright (c) 2015年 Sian. All rights reserved.
//

#import "ViewController.h"

@interface ViewController () <UISearchDisplayDelegate, UISearchBarDelegate>

@property (nonatomic, strong) NSMutableArray    *dataArray;

@property (nonatomic, strong) NSArray           *searchArray;

@property (nonatomic, strong) UISearchDisplayController *searchDisplay;

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.dataArray = [NSMutableArray arrayWithObjects:@"a", @"b", @"c", @"d", @"e", nil];
    self.searchArray = [self.dataArray mutableCopy];
    UISearchBar *searchBar = [[UISearchBar alloc] initWithFrame:CGRectMake(0, 0, 0, 44)];
    searchBar.delegate = self;
    self.tableView.tableHeaderView = searchBar;
    self.searchDisplay = [[UISearchDisplayController alloc] initWithSearchBar:searchBar contentsController:self];
    self.searchDisplay.searchResultsDataSource = self;  // 搜索结果表格DataSource
    self.searchDisplay.searchResultsDelegate = self;    // 搜索结果表格Delegate
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.dataArray.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"SATestCell"];
    if (cell == nil){
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:@"SATestCell"];
    }
    cell.textLabel.text = self.dataArray[indexPath.row];
    return cell;
}

#pragma mark - UISearchBar代理方法
/// 搜索框内容发生变化时调用
- (void)searchBar:(UISearchBar *)searchBar textDidChange:(NSString *)searchText
{
    [self.dataArray removeAllObjects];
    for (NSString *string in self.searchArray) {
        if ([string rangeOfString:searchText].length || searchText.length == 0){
            [self.dataArray addObject:string];
        }
    }
    [self.tableView reloadData];    // 如果使用UISearchDisplayController这句代码则没必要
}
/// 取消搜索时调用
- (void)searchBarTextDidEndEditing:(UISearchBar *)searchBar
{
    self.dataArray = [self.searchArray mutableCopy];
    [self.tableView reloadData];
}

@end

